/*
   Declarations for the mini-studio.
*/

#define INTOARRAY(l) ((short) ((l) & 0xff))
#define COMMANDLINES 256
#define COMMANDWIDTH 133
#define HISTORY_SIZE 40

typedef struct
{
  long lNumLines;
  long lCurLine;
  long lBottomLine;
  int iHorizPos;
  HFONT hFont;
  char szBuf[COMMANDLINES][COMMANDWIDTH];
} LISTINFO, *PLISTINFO;

typedef struct
{
  HWND hwndEdit;
  HWND hwndList;
  LPSTR szHistory[HISTORY_SIZE];
  int iCurHistory,iViewHistory;
  int iNumLoad;
  FARPROC lpProc;
  HWND hwndLoad;
  BOOL bInRead;
  BOOL bHoldBump;
  LPSTR szReadBuf;
} COMMANDINFO, * PCOMMANDINFO;

#define BUFFSIZE 8192
#define BUFFWIDTH 133

typedef struct
{
  HFONT hFont;
  unsigned short usBufULLine,usBufNumLines,usBufLength;
  int iHorizPos;
  char szBuf[BUFFSIZE];
} BUFFINFO, * PBUFFINFO;

typedef struct
{
  HWND hwndIndex;
  HWND hwndInstance;
  HWND hwndBuff;
  HWND hwndTempIO;
  HWND hwndCheck;
  HWND hwndCheck2;
  HWND hwndCompile;
  int iSBFontHeight;
  LPSTR szBuff;
  long lBufLen;
  long lActualBufLen;
  LPSTR szCurInstance;
  int iCurIndex;
  int iIsCompiledControl;
  BOOL bInEvalString;
  BOOL bBuffModified;
  BOOL bShowInheritance;
  BOOL bShowValue;
  BOOL bResetState;
  int iDividingPixels;
  BOOL bHasCapture;
} BROWSEINFO, * PBROWSEINFO;

#define USE_DT_FLAGS \
        (DT_EXTERNALLEADING | DT_LEFT | DT_EXPANDTABS | DT_NOPREFIX | DT_TOP)

/* strings */
#include "artmenu.h"

#include "artdlg.h"

/* messages */
#define MYWM_RESIZE            WM_USER +  1
#define MYWM_INIT              WM_USER +  2
#define MYWM_SETSTR            WM_USER +  3
#define MYWM_ADDTEXT           WM_USER +  4
#define MYWM_PLACE_SCROLL      WM_USER +  5
#define MYWM_INIT_LIST         WM_USER +  6
#define MYWM_INITMENU          WM_USER +  7
#define MYWM_UPDATE            WM_USER +  8
#define MYWM_THROWN            WM_USER +  9
#define MYWM_HISTPREV          WM_USER + 10
#define MYWM_HISTNEXT          WM_USER + 11
#define MYWM_SET_STATE         WM_USER + 12
#define MYWM_REGFILE           WM_USER + 13
#define MYWM_UNREGFILE         WM_USER + 14
#define MYWM_DEFINE_RULE       WM_USER + 15
#define MYWM_DEFINE_DEFFACTS   WM_USER + 16
#define MYWM_DEFINE_DEFEXT     WM_USER + 17
#define MYWM_DEFINE_DEFSCHEMA  WM_USER + 18
#define MYWM_DEFINE_FUN        WM_USER + 19
#define MYWM_DEFINE_DEFGLOBAL  WM_USER + 20
#define MYWM_APP_CHANGED       WM_USER + 21
#define MYWM_IS_LOADING        WM_USER + 22
#define MYWM_CLOSE_BROWSERS    WM_USER + 23
#define MYWM_GET_PRINTREP      WM_USER + 24
#define MYWM_COLLECT_TEXT      WM_USER + 25
#define MYWM_START_READ        WM_USER + 26
#define MYWM_STILL_IN_READ     WM_USER + 27
#define MYWM_DELETE_ITEM       WM_USER + 28
#define MYWM_HOLD_BUMP         WM_USER + 29
#define MYWM_SET_EXPORT_FILE   WM_USER + 30
#define MYWM_ZERO_LOAD_DIALOG  WM_USER + 31
#define MYWM_LOAD_INITIAL_FILE WM_USER + 32
#define MYWM_ABORT_IMPORT      WM_USER + 33
#define MYWM_RES_SETSTR        WM_USER + 34
#define MYWM_CLIPBOARD_DELTA   WM_USER + 35
#define MYWM_ASSERT_FACT       WM_USER + 36
#define MYWM_ASSERT_SCHEMA     WM_USER + 37
#define MYWM_IN_EVAL           WM_USER + 38
#define MYWM_NEWBROWSEITEM     WM_USER + 39

/* Construct Types */
#define CONSTRUCT_RULE     1
#define CONSTRUCT_FACT     2
#define CONSTRUCT_EXT      3
#define CONSTRUCT_SCHEMA   4
#define CONSTRUCT_FUN      5
#define CONSTRUCT_GLOBAL   6
                           
/* carriage return and line feed */
#define LF ((char) 10)
#define CR ((char) 13)

/* global variables */
extern HFONT hNormalFont,hItalicFont,hSemiBoldFont,hBoldFont,hUnderlineFont,
             hStatusFont,hAppFont,hAppCmndFont,hCourierFont;
extern HANDLE hInst;
extern LPSTR szAppName,szCurrentApp,szCurrentDefaultFile;
extern HWND hwndIO,hMDIClientWnd,hAppWnd,hStatusWnd,hwndCommand,hwndBanner,
            hRealStatusWnd;
extern HANDLE hHourGlass,hArrow;
extern HANDLE hAccTable;
extern WORD wAppCmdShow;
extern art_stream asIOStream;
extern BOOL bActualAppName,bAppOpen,bPerformingRegister,bInEmptyEvents,
            bRunning,bResetOnOpen,bStudioCalledClear;


/* functions not in proto.h! */
extern art_object def_user_fun(char *,char *,char *,char *,char *,char *,
                               VOID_PTR,char *,boolean,boolean,boolean,
                               boolean,boolean,boolean,boolean);
extern int add_internal_asynch_fun(void *);
extern void calc_mem_data(unsigned long *,unsigned long *,unsigned long *);
extern long for_sequences_of_deffacts(art_symbol,boolean (*)(),VOID_PTR);
extern art_symbol function_type(art_object,art_symbol);
extern art_object intern_system_data(char *,boolean);
extern long for_all_rules(boolean (*)());
extern long for_all_deffacts(boolean (*)(),VOID_PTR);
extern long for_all_global_vars(boolean (*)(),VOID_PTR);
extern long for_all_functions(boolean (*)(),VOID_PTR );
extern boolean pprule(art_symbol,art_stream);
extern boolean	ppdeffacts(art_symbol,art_stream);
extern boolean a_ppfun(art_symbol,art_stream);
extern boolean a_ppdefglobal(art_symbol,art_stream);
extern boolean a_ppdefschema(art_symbol,boolean,art_stream);
extern boolean a_ppschema(art_symbol,art_stream);
extern boolean a_undefrule(art_symbol);
extern boolean a_undefschema(art_symbol);
extern boolean schema_reset_data_p(art_symbol,art_symbol,art_object);
extern boolean a_add_reset_hook(void (*fun)());

/* term.c */
BOOL FAR PASCAL About(HWND,unsigned,WORD,LONG);
long FAR PASCAL StatusWndProc(HWND,unsigned,WORD,LONG);
BOOL FAR PASCAL TraceDlgProc(HWND,unsigned,WORD,LONG);
int PASCAL WinMain(HANDLE, HANDLE,LPSTR, int);
long FAR PASCAL MainWndProc(HWND,unsigned,WORD,LONG);
HWND MakeMDI(LPSTR,LPSTR,WORD);
BOOL CreateNonameApp(BOOL);
void SetAppTitle(LPSTR);
void OpenAApp(LPSTR,int,HWND,BOOL);

/* terminit.c */
void LoadInitialFile(LPSTR);
BOOL InitApplication(HANDLE);
BOOL InitInstance(HANDLE, int);
BOOL CreateFonts(void);
void init_win_studio(void);
long FAR PASCAL BannerWndProc(HWND,unsigned,WORD,LONG);
void ShowBanner(void);
void AbortLoadFile(void);

/* browse.c */
long FAR PASCAL BrowseWndProc(HWND,unsigned,WORD,LONG);
BOOL FAR PASCAL ExportFileDlgProc(HWND,unsigned,WORD,LONG);
BOOL FAR PASCAL CompileErrorDlgProc(HWND,unsigned,WORD,LONG);

/* cmnd.c */
long FAR PASCAL CommandWndProc(HWND,unsigned,WORD,LONG);
BOOL FAR PASCAL LoadingDlgProc(HWND,unsigned,WORD,LONG);

/* listwnd.c */
long FAR PASCAL ListWndProc(HWND,unsigned,WORD,LONG);

/* opendlg.c */
BOOL FAR PASCAL FileOpenProc(HWND,unsigned,WORD,LONG);
BOOL RunOpenDialog(HWND,LPSTR FAR *,LPSTR,LPSTR,LPSTR);

/* wndstrm.c */
void SetupStream(void);

/* wndutils.c */
void WindowRectMinusScroll(HWND,LPRECT);
int GetAvgCharWidth(HWND,HFONT);
int RowsPerWindow(HWND,int);
void MBox(HWND,LPSTR,BOOL);
void DrawListboxItem(LPDRAWITEMSTRUCT);
int GetLineHeight(HWND,HFONT);
void SaveWindowPos(HWND,LPSTR,BOOL);
int GetWindowPos(HWND,LPSTR);
void BeepIfEnabled(WORD);
void PassOnToEdit(unsigned,WORD,LONG);
void SaveFontProf(int,LPSTR);
int GetFontProf(LPSTR);
LPSTR GetListboxText(HWND,WORD);
LPSTR GetComboboxText(HWND,WORD);
LPSTR LoadResString(WORD,WORD);
void ShowResError(HWND,WORD,BOOL);
void FreeResString(LPSTR);
LONG SendToActiveMDI(WORD,WORD,LONG);
LONG SendToMDIChildren(WORD,WORD,LONG);
void CenterDialog(HWND);
int GetWindowState(LPSTR);
int SaveWindowState(HWND,LPSTR);
int CountMDIChildren(void);
WORD FAR PASCAL BreakString(LPSTR,LPSTR,WORD,WORD);
WORD FAR PASCAL RenameFile(LPSTR,LPSTR);
WORD FAR PASCAL DeleteFile(LPSTR);
WORD FAR PASCAL ClearMemory(LPSTR,WORD);
WORD FAR PASCAL CopyFile(LPSTR,LPSTR);
WORD FAR PASCAL FileExists(LPSTR);
void CopyJustFileName(LPSTR,LPSTR);
BOOL IsJustAFilename(LPSTR);
BOOL FindAndSelectString(HWND,LPSTR);
BOOL FindAndSelectCBString(HWND,LPSTR);
void SaveGenericProf(LPSTR,int);
int GetGenericProf(LPSTR,int);

/* apprep.c */
short RepInit(void);
short RepCreateApp(LPSTR);
short RepOpenApp(LPSTR);
short RepCloseApp(BOOL,LPSTR);
short RepCopyApp(LPSTR,LPSTR);
short RepCompareNames(LPSTR,LPSTR);
short RepRenameFile(LPSTR,LPSTR);
short RepDeleteFile(LPSTR);
short RepAddFile(LPSTR,short FAR *);
short RepFileIDToName(short,LPSTR);
short RepFileNameToID(LPSTR,short FAR *);
short RepEnumFiles(BOOL,LPSTR,short FAR *);
short RepAdd(LPSTR,LPSTR,short,short);
short RepDelete(LPSTR,short FAR *);
short RepChange(LPSTR,short,short);
short RepFind(LPSTR,LPSTR FAR *,short FAR *,short FAR *);
short RepEnumConstructs(BOOL,LPSTR FAR *,short FAR *,short);
short RepAppChanged(void);
short RepAppExists(LPSTR);

/* compress.c */
#define COMPE_MEMORY_FAIL 600
#define COMPE_EXPANSION_FAIL 601
#define COMPE_INVALID_ERROR 602
extern short CompCompress(LPSTR,unsigned short,LPSTR *,unsigned short *);
extern short CompDeCompress(LPSTR,unsigned short,LPSTR *,unsigned short *);
extern short CompErrorToString(short,LPSTR);

/* saveas.c */
BOOL FAR PASCAL SaveAsDlgProc(HWND,unsigned,WORD,LONG);

/* impexp.c */
void RegisterApp(LPSTR);
BOOL FAR PASCAL DefaultFileDlgProc(HWND,unsigned,WORD,LONG);
BOOL FAR PASCAL ExportDlgProc(HWND,unsigned,WORD,LONG);

/* debug.c */
void QueryCurrentWatches(boolean *,boolean *,boolean *,boolean *);
art_object a_set_browser_update(art_object);
art_object a_get_browser_update(void);
art_object a_get_runtime_io_window(void);
art_object a_set_runtime_io_window(art_object);
art_object a_get_more_mode(void);
art_object a_set_more_mode(art_object);

